--
-- $Id: test_bench.vhdl,v 1.1 2009-02-17 12:37:34 potyra Exp $
--

library expect;
use expect.types.all;
use expect.procedures.all;

entity test_bench is
end test_bench;

architecture structural of test_bench is
	signal ext_eth0 : eth;
	signal ext_usb0 : usb_bus;
	signal ext_usb1 : usb_bus;
	signal ext_par : parallel;
	signal ext_ser0 : serial;
	signal ext_ser1 : serial;
	signal ext_speaker : sound;

	signal power_switch : boolean;
	signal power_button : boolean;
	signal reset_button : boolean;

	signal cdrom : cstring;
	signal floppy : cstring;

	signal key : boolean_array(0 to 127);

	signal mouse_dx : integer;
	signal mouse_dy : integer;
	signal mouse_dz : integer;
	signal mouse_button1 : boolean;
	signal mouse_button2 : boolean;
	signal mouse_button3 : boolean;
	signal mouse_button4 : boolean;
	signal mouse_button5 : boolean;

	signal screen_shot : integer;

	signal opt_screen : opt_rgb;
begin
	pc : pc_standard
		generic map(
			memsize => 64,
			disksize => 1
		)
		port map(
			ext_eth0 => ext_eth0,
			ext_usb0 => ext_usb0,
			ext_usb1 => ext_usb1,
			ext_par => ext_par,
			ext_ser0 => ext_ser0,
			ext_ser1 => ext_ser1,
			ext_speaker => ext_speaker,
			power_switch => power_switch,
			power_button => power_button,
			reset_button => reset_button,

			cdrom => cdrom,
			floppy => floppy,

			key => key,

			mouse_dx => mouse_dx,
			mouse_dy => mouse_dy,
			mouse_dz => mouse_dz,
			mouse_button1 => mouse_button1,
			mouse_button2 => mouse_button2,
			mouse_button3 => mouse_button3,
			mouse_button4 => mouse_button4,
			mouse_button5 => mouse_button5,

			screen_shot => screen_shot,

			opt_screen => opt_screen
		);
	loudspeaker : loudspeaker
		port map(
			sound_in => ext_speaker
		);
	user : user
		port map(
			power_switch => power_switch,
			power_button => power_button,
			reset_button => reset_button,

			cdrom => cdrom,
			floppy => floppy,

			key => key,

			mouse_dx => mouse_dx,
			mouse_dy => mouse_dy,
			mouse_dz => mouse_dz,
			mouse_button1 => mouse_button1,
			mouse_button2 => mouse_button2,
			mouse_button3 => mouse_button3,
			mouse_button4 => mouse_button4,
			mouse_button5 => mouse_button5,

			screen_shot => screen_shot,

			opt_screen => opt_screen
		);
end structural;
